; copyright: Stephan Bartl, 1st version on October 8th, 2014
; script name: XYAHK_inlineRenameOldStyle
; version 0.002
; version 0.003  - 200205: The inline rename edit fields' EditNN names changed in XY. Updated those EditNN names and put them into a variable defined at the beginning.
#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
#Persistent
#SingleInstance force
titleMatchStringForXY := "XYplorer ahk_class ThunderRT6FormDC"
editNNof_XY_RPanel_Catalog_LPanel_Tree := "Edit16|Edit18|Edit19|Edit20"
SetTitleMatchMode, 2
SetKeyDelay, 0

#if editNNHavingFocus := _XYOneOfEditNNHasFocus(editNNof_XY_RPanel_Catalog_LPanel_Tree, titleMatchStringForXY)
Left::
ControlGet, selectedText, Selected, , %editNNHavingFocus%, %titleMatchStringForXY%
if (selectedText)
   ControlSend, %editNNHavingFocus%, {Right}{Left}, %titleMatchStringForXY%
else
   ControlSend, %editNNHavingFocus%, {Left}, %titleMatchStringForXY%
return

Right::
ControlGet, selectedText, Selected, , %editNNHavingFocus%, %titleMatchStringForXY%
if (selectedText)
   ControlSend, %editNNHavingFocus%, {Right}{Right}, %titleMatchStringForXY%
else
   ControlSend, %editNNHavingFocus%, {Right}, %titleMatchStringForXY%
return

Up::
ControlGet, selectedText, Selected, , %editNNHavingFocus%, %titleMatchStringForXY%
if (selectedText)
   ControlSend, %editNNHavingFocus%, {Right}{Up}, %titleMatchStringForXY%
else
   ControlSend, %editNNHavingFocus%, {Up}, %titleMatchStringForXY%
return

Down::
ControlGet, selectedText, Selected, , %editNNHavingFocus%, %titleMatchStringForXY%
if (selectedText)
   ControlSend, %editNNHavingFocus%, {Right}{Down}, %titleMatchStringForXY%
else
   ControlSend, %editNNHavingFocus%, {Down}, %titleMatchStringForXY%
return

End::
;~ indexOfTargetChar := 3
;~ ControlGet, hEdit, Hwnd, , %editNNHavingFocus%, %titleMatchStringForXY%
;~ Edit_PosFromChar(hEdit, indexOfTargetChar, X, Y)
;~ MsgBox x:%x% y:%y%
;~ VarSetCapacity(iX, 4, 0)
;~ VarSetCapacity(iY, 4, 0)
;~ NumPut(X, iX, 0, "Int")
;~ NumPut(Y, iY, 0, "Int")
;~ DllCall("User32.dll\SetCaretPos", "Int", iX, "Int", iY)

VarSetCapacity(POINT, 8, 0)
DllCall("User32.dll\GetCaretPos", "Ptr", &POINT)
X := NumGet(POINT, 0, "Int")
Y := NumGet(POINT, 4, "Int")
ControlGet, hEdit, Hwnd, , %editNNHavingFocus%, %titleMatchStringForXY%
EM_CHARFROMPOS(hEdit, X, Y, CharPos, Line)
EM_GETSEL(HEDIT, Start, End)
MsgBox x: %X% y: %Y% hEdit: %hEdit% charPos: %CharPos%
;~ MsgBox, 0, Selection, Start: %Start%`nEnd: %End%`nCaret: %CharPos%
return
#if

_XYOneOfEditNNHasFocus(listOfEditNNs, WinTitle)
{
   ControlGetFocus, focusedControl, %WinTitle%
   return InStr(listOfEditNNs . "|", focusedControl . "|") ? focusedControl : 0
}

; ======================================================================================================================
; Gets the starting and ending character positions of the current selection in an edit control.
; Start  -  receives the start of the current selection
; End    -  receives the end of the current selection
; ======================================================================================================================
EM_GETSEL(HWND, ByRef Start, ByRef End) {
   ; EM_GETSEL = 0x00B0 -> msdn.microsoft.com/en-us/library/bb761598(v=vs.85).aspx
   Start := End := 0
   DllCall("User32.dll\SendMessage", "Ptr", HWND, "UInt", 0x00B0, "UIntP", Start, "UIntP", End, "Ptr")
   Start++, End++
   Return True
}

; ======================================================================================================================
; Gets information about the character closest to a specified point in the client area of an edit control.
; X, Y            -  the X- and Y-positions of the point.
; CharPos, Line   -  receive the character position and the line number.
; ======================================================================================================================
EM_CHARFROMPOS(HWND, X, Y, ByRef CharPos, ByRef Line) {
   ; EM_CHARFROMPOS = 0x00D7 -> msdn.microsoft.com/en-us/library/bb761566(v=vs.85).aspx
   CharPos := Line := 0
   CharLine := DllCall("User32.dll\SendMessage", "Ptr", HWND, "UInt", 0x00D7, "Ptr", 0, "UInt", (Y << 16) | X, "Ptr")
   CharPos := (CharLine & 0xFFFF) + 1
   Line := (CharLine >> 16) + 1
   Return True
}

Edit_PosFromChar(hEdit,p_CharPos,ByRef X,ByRef Y) ;I found this function in one of the ahk forums
    {
    Static EM_POSFROMCHAR:=0xD6
    SendMessage EM_POSFROMCHAR,p_CharPos,0,,ahk_id %hEdit%
    X:=(ErrorLevel & 0xFFFF)<<48>>48
        ;-- LOWORD of result and converted from UShort to Short
    Y:=(ErrorLevel>>16)<<48>>48
        ;-- HIWORD of result and converted from UShort to Short
    }